# HG changeset patch
# User Jim Unroe <rock.unroe@gmail.com>
# Date 1358853990 18000
# Node ID ca59b959c3866fb5ea79d6e94532863d546ee34b
# Parent  ae858d5f3c893962f8cbe2f08d7ed669d3e2610d
[mq]: test_vfo_freq_settings

diff -r ae858d5f3c89 -r ca59b959c386 chirp/uv5r.py
--- a/chirp/uv5r.py	Sat Jan 19 16:39:58 2013 -0500
+++ b/chirp/uv5r.py	Tue Jan 22 06:26:30 2013 -0500
@@ -945,6 +945,37 @@
                                                     STEP_LIST[self._memobj.vfob.step]))
             workmode.append(rs)
 
+        def convert_bytes_to_freq(bytes):
+           real_freq = 0
+           for byte in bytes:
+               real_freq = (real_freq * 10) + byte
+           return real_freq / 100000.0
+
+        def convert_freq_to_bytes(real_freq):
+            bytes = [ 0 for x in range(0,8) ]   # init list with 8 times 0
+            real_freq = int(freq * 100000)      # it has to be integer
+            for i in range(7, -1, -1):          # go from 7 to 0
+                bytes[i] = real_freq%10         # extract last digit
+                real_freq /= 10                 # throw away last digit
+            return bytes
+
+        def my_validate(value):
+            if value < 400 and value > 174:
+                raise InvalidValueError("Can't be between 174-400")
+            return value
+
+        val1a = RadioSettingValueFloat(136, 512,
+                               convert_bytes_to_freq(self._memobj.vfoa.freq))
+        val1a.set_callback(my_validate)
+        rs = RadioSetting("vfoa.freq", "VFO A Frequency", val1a)
+        workmode.append(rs)
+
+        val1b = RadioSettingValueFloat(136, 512,
+                               convert_bytes_to_freq(self._memobj.vfob.freq))
+        val1b.set_callback(my_validate)
+        rs = RadioSetting("vfob.freq", "VFO B Frequency", val1b)
+        workmode.append(rs)
+
         test = RadioSettingGroup("test", "test")
         group.append(test)
         def my_validate(value):
@@ -959,12 +990,24 @@
 
         return group
 
+    def convert_freq_to_bytes(real_freq):
+        bytes = [ 0 for x in range(0,8) ]   # init list with 8 times 0
+        real_freq = int(freq * 100000)      # it has to be integer
+        for i in range(7, -1, -1):          # go from 7 to 0
+            bytes[i] = real_freq%10         # extract last digit
+            real_freq /= 10                 # throw away last digit
+        return bytes
+
     def set_settings(self, settings):
         _settings = self._memobj.settings[0]
         for element in settings:
             if not isinstance(element, RadioSetting):
                 self.set_settings(element)
                 continue
+            elif element.get_name() == "vfoa.freq":
+                convert_freq_to_bytes(self._memobj.vfoa.freq, element.value)
+            elif element.get_name() == "vfob.freq":
+                convert_freq_to_bytes(self._memobj.vfob.freq, element.value)
             try:
                 if "." in element.get_name():
                     bits = element.get_name().split(".")
